/*****************************************************************************
 * Module containing setup definitions and setup dialog window code          *
 *                                                                           *
 * Include header file                                                       *
 *                                                                           *
 *****************************************************************************/

#ifndef CONFIG_H
#define CONFIG_H

#define INCL_WIN
#define INCL_GPI
#define INCL_DOSRESOURCES
#define INCL_DOSMISC
#define INCL_DOS
#define INCL_DOSERRORS
#include <os2.h>

#ifdef DEBUG_BUILD
  #define SETUP_DEBUG_BUILD
  #include <stdio.h>
#endif

// Constants

#define SETUP_CALLED_FROM_NETGAMECLIENT  0
#define SETUP_CALLED_FROM_GAMEDLL        1

#define MIN_ACCEPTABLE_FREQ     4000
#define MAX_ACCEPTABLE_FREQ     48200
#define MIN_ACCEPTABLE_NUMBUFS  2
#define MAX_ACCEPTABLE_NUMBUFS  64
#define MIN_ACCEPTABLE_BUFSIZE  64
#define MAX_ACCEPTABLE_BUFSIZE  65536

// Type declarations for storing the configuration
typedef struct _tConfig
{
  int SFXDeviceID;
  int SFXDeviceShared;
  int SFXFreq;
  int SFXBits;
  int SFXChannels;
  int SFXNumBufs;
  int SFXBufSize;
  char SkinFilename[256];
  int iMainVolume;
  int iMusicVolume;
  int iSFXVolume;
} tConfig, *pConfig;

extern tConfig CurrentConfig; // Current configuration
extern tConfig NewConfig;     // New configuration, to change to!
extern BOOL bNewConfigAvailable; // Flag to indicate when to change config! (usually when Apply button pressed)

// Functions of module:
void LoadConfig(pConfig Config); // Loads configuration into Config, or loads default one.
void SaveConfig(pConfig Config); // Saves config
int SetupWindowProcessing(HAB hAB, HMQ hMQ, HWND hwndParent, HMODULE hDLLHandle, int iCalledFrom);
#endif
