/*****************************************************************************
 * Font support library                                                      *
 *                                                                           *
 * Include file to use custom fonts.                                         *
 *****************************************************************************/
#ifndef FONTS_H
#define FONTS_H

#ifdef DEBUG_BUILD
//  #define FONTS_DEBUG_BUILD
  #include <stdio.h> // fflush
#endif

#include "Sprites.h"  // Fonts uses sprites
#include "Images.h"   // and images

// Type declarations for the Fonts module:
typedef struct _tFont
{
  pSprite Character[256];
  int iHeight;
} tFont, *pFont;

// Functions of Fonts module:
// See the .c code for description!

void InitializeFonts();
void UninitializeFonts();

void LoadFontDef(pFont *pTheFont, pImage Image, char *Params);
void SetFontHeight(pFont *pTheFont, int iHeight);
void CleanupFont(pFont Font);

void DrawText(unsigned char *pBuffer, unsigned long ulDstBufWidth,
	      long vptlx, long vptly, long vpbrx, long vpbry,
	      long xpos, long ypos,
	      char *text,
              pFont TheFont, unsigned char Visibility);

#endif
