/*****************************************************************************
 * Frame regulation library                                                  *
 *                                                                           *
 * Include file to use frame regulation APIs                                 *
 *****************************************************************************/
#ifndef FRAMEREGULATION_H
#define FRAMEREGULATION_H

#define INCL_DOS
#include <os2.h>

#include <math.h> // we're using floats!

#ifdef DEBUG_BUILD
//  #define FR_DEBUG_BUILD
  #include <stdio.h>
#endif

// Usable functions:
// See the .c code for description!

int InitializeFrameRegulation(HEV hevSem);
void UninitializeFrameRegulation();
void SetupFrameRegulation( float flFPS );

void Initialize_ulInitTimeStamp();

// Usable exported variables:
// ulInitTimeStamp:
//   Timestamp, when the FrameRegulator has been initialized.
//   Exported, so other threads can use it!
extern ULONG ulInitTimeStamp;
// ulCurrTimeStamp:
//   Current time, since boot of OS/2, in msecs.
//   Exported, so other threads can use it!
extern ULONG ulCurrTimeStamp;
// Using these two variables above, a normal clock, measuring time, 
// can be fabricated, than counts the in-game time.

#endif
