/*****************************************************************************
 * Image support library                                                     *
 *                                                                           *
 * Include header file                                                       *
 *                                                                           *
 * This library can be used to load and unpack images into BGR3 truecolor    *
 * format.                                                                   *
 * Currently only truecolor PCX files are supported.                         *
 *****************************************************************************/

#ifndef IMAGES_H
#define IMAGES_H

#ifdef DEBUG_BUILD
//  #define IMAGES_DEBUG_BUILD
  #include <stdio.h>
#endif

// Type declarations for the Images module:
typedef struct _tImage
{
  char *sFileName;
  unsigned char *pImageData;
  unsigned long ulImageSize;
  unsigned long ulWidth;
  unsigned long ulHeight;
} tImage, *pImage;

// Functions of Images module:

void InitializeImages();
void UninitializeImages();

pImage LoadPCX(char *filename);
void CleanupImage(pImage Image);

#endif
