//-------------------------------------------------------------------------------------------------------------
//
// Direct client connection handling functions
//
//-------------------------------------------------------------------------------------------------------------

type pDirectClientList=^tDirectClientList; // Description of an active direct client
     tDirectClientList=record
       ThreadID:TID;                 {My ThreadID}
       MySocket:longint;             {The socket that can be used to communicate with the other end}
       Remote:SockAddr_In;           {The ip address and port of the other side}

       GameToInvite:pGameList;         {Only for invitor threads: the game to invite for}
       PlayerToInvite:pPlayerDataList; {Only for invitor threads: the player to invite for}

       Next:pDirectClientList;
     end;

var  DirectClientListHead:pDirectClientList;
     DirectClientDatasProtector_Sem:HEv;

function AddNewDirectClient(data:tDirectClientList):pDirectClientList;
var Prev,Temp:pDirectClientList;
begin
  if DirectClientDatasProtector_Sem<>-1 then
    DosRequestMutexSem(DirectClientDatasProtector_Sem, sem_indefinite_wait);

  Prev:=Nil;
  Temp:=DirectClientListHead;
  while Temp<>Nil do
  begin
    Prev:=Temp;
    Temp:=Temp^.Next;
  end;
  Result:=New(pDirectClientList);
  Result^:=data;
  Result^ .Next:=Nil;
  if Prev=Nil then DirectClientListHead:=Result else
    Prev^.Next:=Result;

  inc(NumOfLocalServerClients);

  if DirectClientDatasProtector_Sem<>-1 then
    DosReleaseMutexSem(DirectClientDatasProtector_Sem);
end;

procedure DeleteOldDirectClient(data:pDirectClientList);
var Prev,Temp:pDirectClientList;
    Msg:String;
begin
  if DirectClientDatasProtector_Sem<>-1 then
    DosRequestMutexSem(DirectClientDatasProtector_Sem, sem_indefinite_wait);

  Prev:=Nil;
  Temp:=DirectClientListHead;
  while (Temp<>Nil) and (Temp<>data) do
  begin
    Prev:=Temp;
    Temp:=Temp^.Next;
  end;
  if temp<>nil then
  begin // Found, delete it!
    if Prev=Nil then DirectClientListHead:=Temp^.Next else
    Prev^.Next:=Temp^.Next;

    Dispose(Temp);

    dec(NumOfLocalServerClients);
  end;

  if DirectClientDatasProtector_Sem<>-1 then
    DosReleaseMutexSem(DirectClientDatasProtector_Sem);
end;

