//-------------------------------------------------------------------------------------------------------------
//                                      Include file for NetGameClient
//
// GameDLL Load/Unload (Per thread) functions and variables
//
// Variables (ThreadVars):
//   GameDLLHandle (handle of loaded gamedll in thread)
// Functions/Procedures:
//   function LoadGameDLL(FName:string):boolean;
//   function UnloadGameDLL:boolean;
//   InitializeGameDLL
//   StartGame_*Mode
//
//-------------------------------------------------------------------------------------------------------------

threadvar InitializeGameDLL:fnInitializeGameDLL;
          StartGame_ClientMode:fnStartGame_ClientMode;
          StartGame_ServerMode:fnStartGame_ServerMode;

          GameDLLHandle:HMODULE;

function LoadGameDLL(FName:string):boolean;
var rc:ApiRet;
    s:String;
begin
  result:=false;
  FName:=FName+#0;
  rc:=DosLoadModule(nil, 0, @FName[1], GameDLLHandle);
  if rc<>no_error then
  begin
    s:='DosLoadModule rc='+LongToStr(rc)+#13+#10+'fname: '+fname;
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, @s[1],'Error loading DLL', 0, MB_OK or MB_MOVEABLE or MB_ICONEXCLAMATION);
    exit;
  end;
  rc:=DosQueryProcAddr(GameDLLHandle, 0, 'InitializeGameDLL', @InitializeGameDLL);
  if rc<>no_error then
  begin
    DosFreeModule(GameDLLHandle);
    exit;
  end;
  rc:=DosQueryProcAddr(GameDLLHandle, 0, 'StartGame_ClientMode', @StartGame_ClientMode);
  if rc<>no_error then
  begin
    DosFreeModule(GameDLLHandle);
    exit;
  end;
  rc:=DosQueryProcAddr(GameDLLHandle, 0, 'StartGame_ServerMode', @StartGame_ServerMode);
  if rc<>no_error then
  begin
    DosFreeModule(GameDLLHandle);
    exit;
  end;
  result:=true;
end;

function UnloadGameDLL:boolean;
begin
  DosFreeModule(GameDLLHandle);
  result:=true;
end;

