unit GameDLLdef;  // Defines for GameDLLs
{$Use32+}
{&cdecl+}
interface
uses os2def;

// ----------------------------------------- Game types -------
const GT_DUEL        = 0;  // Simple two-player game
      GT_MULTIPLAYER = 1;  // Multiplayer game

// ----------------------------------------- General contants -

const MAX_GAMENAME_LENGTH=40;
      MAX_GAMEDESC_LENGTH=512;
      MAX_USERNAME_LENGTH=20;

// ----------------------------------------- GameInfoBuf ------
type pGameInfoBuf = ^tGameInfoBuf;
     tGameInfoBuf = packed record
       bGameVerMaj : byte;             // Game Major version number
       bGameVerMin : byte;             // Game Minor version number
       sGameVerRel : SmallWord;        // Game release/build number
       sGameNetCommVerMaj : SmallWord; // Version of network communication protocol
       sGameNetCommVerMin : SmallWord; //  (Only the same game with same NetComm version can communcate!)
       csGameName  : array [0..MAX_GAMENAME_LENGTH-1] of char;  // Short name of game
       csGameDesc  : array [0..MAX_GAMEDESC_LENGTH-1] of char;  // Description of game
       lGameType   : longint;          // Type of game (see GT_* contants)
     end;

type fnSendMessage    = function(Socket:longint; Msg:pchar):LongBool;
     fnReceiveMessage = function(Socket:longint; cbBufSize:longint; MsgBuf:pchar; TimeOut:longint):LongBool;

     pInitBuf = ^tInitBuf;
     tInitBuf = packed record
       SendMessage    : ^fnSendMessage;
       ReceiveMessage : ^fnReceiveMessage;
     end;

type pStartClientBuf = ^tStartClientBuf;
     tStartClientBuf = packed record
       Socket   : longint;
       AB:HAB; // Anchor block  (Initialized for the thread)
       MQ:HMQ; // Message Queue (Initialized for the thread)
       hMod:HMODULE; // Handle of the DLL (to be able to use resources from it)
       LocalUserName  : array[0..MAX_USERNAME_LENGTH-1] of char;
       RemoteUserName : array[0..MAX_USERNAME_LENGTH-1] of char;
     end;

type tStartServerBuf = tStartClientBuf;
     pStartServerBuf = ^tStartServerBuf;

type pSetupGameBuf = ^tSetupGameBuf;
     tSetupGameBuf = packed record
       AB:HAB; // Anchor block  (Initialized for the thread)
       MQ:HMQ; // Message Queue (Initialized for the thread)
       hMod:HMODULE; // Handle of the DLL (to be able to use resources from it)
     end;

// ----------------- DLL Function Declarations -----------------------
type
      fnGetGameInfo = function( BufSize:longint; Buffer:pGameInfoBuf ):LongBool;
      fnInitializeGameDLL = function( BufSize:longint; Buffer:pInitBuf ):LongBool;
      fnStartGame_ClientMode = function( BufSize:longint; Buffer:pStartClientBuf ):LongBool;
      fnStartGame_ServerMode = function( BufSize:longint; Buffer:pStartServerBuf ):LongBool;

// ----------------- Optional DLL function declarations --------------

type  fnSetupGame = function( BufSize:longint; Buffer:pSetupGameBuf ):LongBool;

implementation
end.
