// TODO:
//
//  Invitalaskor ha accept elott bezarodik a masik oldal, akkoris tovabbmegy!
//  DLL-Setup
//
{$DEFINE DebugConsole}

Program NetGameClient;
{$X+}{$H-}{$R-}
{&USE32+}

{$IFDEF DebugConsole}
{$PMTYPE VIO} // We're gonna create a PM application, but start with a VIO application,
              // and morph to a PM one later!
{$ELSE}
{$PMTYPE PM}  // Normal PM application
{$ENDIF}

{$LINKER
  DESCRIPTION      "NetGameClient executable for OS/2 and eComStation"
}

{$R NetGameClient.res}  // The resources will be compiled into this file
                 // by the compiler
uses MemUInfo,   // For memory usage and leak detection
     os2def, os2base,
     vputils, vpSysLow,
     os2PMApi,
     inet,
     CommonNetFuncs,
     GameDLLdef;

var hwndFrame     : HWND;        // Handle of main window frame
    hwndClient    : HWND;        // Handle of main window client area
    hwndDlgClient : HWND;        // Handle of dialog area of main window
    GUI_Ready     : Boolean;     // True if the windows/etc. are created

    ServerComm_Ready:Boolean;    // Server-Communication stuff
    ServerSocket  : longint;
    Reconnect     : boolean;     // Used to indicate that a server-reconnection is required

    LocalServerIP     : longint; // Local server (for Direct Client-to-Client communication) stuff
    LocalServerPort   : longint;
    LocalServerSocket : longint;
    LocalServer_Ready : boolean;
    NumOfLocalServerClients:longint;

    tidPM          : TID;
    tidServerComm  : TID;
    tidLocalServer : TID;

    ShuttingDown  : Boolean;


threadvar AB : HAB;  // Anchor block for the thread
          MQ : HMQ;  // Message queue for the thread

    // Actual settings with defaults
const
    WinStateSave_Name = 'NetGameClient';
    WinStateSave_Key  = 'Main_Window_Presentation_Parameters';
    sUsername   : string = 'Unnamed';
    sServerPort : string = 'localhost:630';
    MyID        : Longint = -1;

    MAX_LOCALSERVERCLIENTS = 25;
    DIRECTCLIENT_TIMEOUT = 5000; // 5 sec (might be per byte) timeout

const {$I NetGameClient.INC} // Read dialog contants
      pszPrivateClassName:pchar='NetGameClientClass';

{$IFDEF DebugConsole}
procedure MorphToPM;
var _pib:PPIB;
    _tib:PTIB;
begin
  DosGetInfoBlocks(_tib, _pib);
  if _pib^.pib_ultype=2 then _pib^.pib_ultype:=3;
end;
{$ENDIF}
{
// Missing sockets call: IOCTL
const FIONBIO=$80000000 or ((longint(sizeof(ulong) and $7f) shl 16) or (ord('f') shl 8) or (126));
function ioctl(s:longint; cmd:longint; data:pointer; dsize:longint):longint; cdecl; external 'SO32DLL' index 8;//name 'IOCTL';
}
procedure InitPM;   // General procedure for initialize PM for threads
begin
  AB:=WinInitialize(0);
  MQ:=WinCreateMsgQueue(AB, 0);
end;

procedure UninitPM; // General procedure for initialize PM for threads
begin
  WinDestroyMsgQueue(MQ);
  WinTerminate(AB);
end;

function AddressPort2String(lSrvAddress:longint;lSrvPort:longint):string;
var adr:pchar;
begin
  adr:=inet_ntoa(lSrvAddress);
  lSrvPort:=ntohs(lSrvPort);
  result:=StrPas(adr)+':'+LongToStr(lSrvPort);
end;

{$I PlayerData_Handling.pas}
{$I GameList_Handling.pas}
{$I GameDLL_Load_Unload.pas}
{$I DirectClient_Handling.pas}

function GetListBoxItemIndexByHandle(wnd:HWND; id:longint; handle:longint):longint;
var c,l,h:longint;
begin
  result:=-1;
  c:=WinSendDlgItemMsg(wnd, id,
                       LM_QUERYITEMCOUNT, 0, 0);
  for l:=0 to c-1 do
  begin
    h:=WinSendDlgItemMsg(wnd, id,
                         LM_QUERYITEMHANDLE, mparam(l), 0);
    if h=handle then
    begin
      result:=l;
      break;
    end;
  end;
end;

function GetSelectedListBoxItemHandle(wnd:HWND; id:longint):longint;
var c:longint;
begin
  c:=WinSendDlgItemMsg(wnd, id,
                       LM_QUERYSELECTION, LIT_FIRST, 0);
  result:=WinSendDlgItemMsg(wnd, id,
                       LM_QUERYITEMHANDLE, mparam(c), 0);
end;

procedure SetStatusLine(s:String);
begin
  s:=s+#0;
  WinSetDlgItemText(hwndDlgClient, ST_STATUSLINE, @s[1]);
end;

procedure SetStatusLineColor(Target, Color:longint);
begin
  WinSetPresParam(WinWindowFromID(hwndDlgClient, ST_STATUSLINE),
                  Target, sizeof(color), @color);
end;

function WinQueryDlgItemTextPas(Wnd:hwnd; id:longint):string;
var lth:longint;
begin
  result:='';
  lth:=WinQueryDlgItemTextLength(Wnd, ID);
  setlength(result,lth+1);
  lth:=WinQueryDlgItemText(Wnd, id, length(result), @result[1]);
  Setlength(result,lth);
end;

procedure WinSetDlgItemTextPas(Wnd:hwnd; id:longint; txt:String);
begin
  txt:=txt+#0;
  WinSetDlgItemText(Wnd, ID, @txt[1]);
end;

threadvar SavedUserName:string;
          SavedServerPort:string;

function AcceptableUserName(s:String):boolean;
var l:longint;
begin
  if length(s)=0 then
  begin
    result:=false;
    exit;
  end;
  result:=true;
  for l:=1 to length(s) do if (s[l] in ['"','''']) then result:=false;
end;

function AcceptableServerPort(s:String):boolean;
var l,lp:longint;
    p:string;
begin
  if length(s)=0 then
  begin
    result:=false;
    exit;
  end;
  result:=true;
  // check for valid characters
  for l:=1 to length(s) do if not (s[l] in ['a'..'z','A'..'Z','0'..'9','.',':']) then result:=false;
  if result=true then
  begin // check for port
    l:=pos(':',s);
    if l=0 then result:=false
    else
    begin
      p:=copy(s,l+1,length(s));
      val(p,lp,l);
      result:=(l=0);
    end;
  end;
end;

function GetGameDescByIndex(ind:longint):string;
var count:longint;
    Act:pGameList;
    sTemp:string;
begin
  Act:=GameListHead;
  count:=0;
  while (Count<ind) and (Act<>nil) do
  begin
    act:=act^.Next;
    inc(Count);
  end;
  if Act=Nil then result:=''
  else
  begin
    with Act^.GameInfo do
    begin
      Result:='Name: '+StrPas(csGameName)+#10+#13+
              'Version: '+LongToStr(bGameVerMaj)+'.'+LongToStr(bGameVerMin)+'.'+LongToStr(sGameVerRel)+
                         ' (NetComm v'+LongToStr(sGameNetCommVerMaj)+'.'+LongToStr(sGameNetCommVerMin)+')'+#10+#13+
              'Type: ';
      Case lGameType of
        GT_DUEL: Result:=Result+'Two-player game';
        GT_MULTIPLAYER: Result:=Result+'Multiplayer game';
        else Result:=Result+'Unknown kind game';
      end;
      result:=result+#10+#13+
              'Description:'+#10+#13+StrPas(csGameDesc)+#10+#13;
    end;
  end;
end;

function GetGameByIndex(ind:longint):pGameList;
var count:longint;
    Act:pGameList;
    sTemp:string;
begin
  Act:=GameListHead;
  count:=0;
  while (Count<ind) and (Act<>nil) do
  begin
    act:=act^.Next; inc(Count);
  end;
  result:=act;
end;

{$I Invitor_stuff.pas}

procedure ResizeMainWindowControls(Wnd:HWND; Width, Height:longint);
var Swp1, Swp2, Swp3:SWP;
    CXDLGFRAME, CYDLGFRAME:ulong;
    ulTemp:ulong;
begin
  WinEnableWindowUpdate(hwndClient, false);
  CXDLGFRAME:=WinQuerySysValue(HWND_DESKTOP, SV_CXDLGFRAME);
  CYDLGFRAME:=WinQuerySysValue(HWND_DESKTOP, SV_CYDLGFRAME);
  // Resize window client:
  WinSetWindowPos(hwndClient, HWND_TOP, 0, 0, Width, Height, SWP_SIZE);
  // Now reposition/resize controls in window
  // First: Set dialog position inside frame window
  WinQueryWindowPos(hwndClient, Swp1);
  WinSetWindowPos(hwndDlgClient, HWND_TOP,
                  -CXDLGFRAME,
                  -CYDLGFRAME,
                  Swp1.cx+2*CXDLGFRAME,
                  Swp1.cy+2*CYDLGFRAME,
                  SWP_SIZE or SWP_MOVE);

  // PB_INVITE
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, PB_INVITE), HWND_TOP,
                  CXDLGFRAME+15,
                  CYDLGFRAME+3,
                  0, 0,
                  SWP_MOVE);

  // PB_QUIT
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_QUIT), Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, PB_QUIT), HWND_TOP,
                  Swp1.cx-Swp2.cx-CXDLGFRAME-5,
                  CYDLGFRAME+3,
                  0, 0,
                  SWP_MOVE);

  // ST_STATUSLINE
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_INVITE), Swp1);
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_QUIT), Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, ST_STATUSLINE), HWND_TOP,
                  Swp1.x+Swp1.cx+5, Swp1.y+4, Swp2.x-5-Swp1.x-Swp1.cx-5, Swp1.cy-8, SWP_SIZE or SWP_MOVE);

  // GB_SETTINGS
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_INVITE), Swp1);
  WinQueryWindowPos(hwndDlgClient, Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, GB_SETTINGS), HWND_TOP,
                  Swp1.x-5, Swp2.cy-89,
                  (Swp2.cx-34) div 2, 80,
                  SWP_SIZE or SWP_MOVE);
  // Things inside GB_SETTINGS:
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, GB_SETTINGS), Swp1);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, ST_SERVER), HWND_TOP,
                  Swp1.x+5, Swp1.y+6,
                  0,0,
                  SWP_MOVE);
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, ST_SERVER), Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, ST_USERNAME), HWND_TOP,
                  Swp1.x+5, Swp1.y+36,
                  0,0,
                  SWP_MOVE);

  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, ST_USERNAME), Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, EF_SERVERPORT), HWND_TOP,
                  Swp2.x+Swp2.cx+CXDLGFRAME+5, Swp1.y+8,
                  Swp1.cx-Swp2.x-Swp2.cx-CXDLGFRAME-5,18,
                  SWP_SIZE or SWP_MOVE);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, EF_USERNAME), HWND_TOP,
                  Swp2.x+Swp2.cx+CXDLGFRAME+5, Swp1.y+38,
                  Swp1.cx-Swp2.x-Swp2.cx-CXDLGFRAME-5, 18,
                  SWP_SIZE or SWP_MOVE);

  // GB_ADVANCEDSETTINGS
  WinQueryWindowPos(hwndDlgClient, Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, GB_ADVANCEDSETTINGS), HWND_TOP,
                  ((Swp2.cx-34) div 2)+20, Swp2.cy-89,
                  (Swp2.cx-34) div 2, 80,
                  SWP_SIZE or SWP_MOVE);
  // Things inside GB_ADVANCEDSETTINGS:
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, GB_ADVANCEDSETTINGS), Swp1);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, CB_AUTOREJECTINVITATIONS), HWND_TOP,
                  Swp1.x+5, Swp1.y+36,
                  Swp1.cx-10,18,
                  SWP_SIZE or SWP_MOVE);

  // GB_AVAILABLEGAMES
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, GB_SETTINGS), Swp1);
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_INVITE), Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, GB_AVAILABLEGAMES), HWND_TOP,
                  Swp1.x, Swp2.y+Swp2.cy+5,
                  Swp1.cx, Swp1.y-(Swp2.y+Swp2.cy)-5,
                  SWP_SIZE or SWP_MOVE);
  // Things inside GB_AVAILABLEGAMES:
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_SETUPGAME), Swp1);
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, GB_AVAILABLEGAMES), Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, PB_SETUPGAME), HWND_TOP,
                  Swp2.x+Swp2.cx-Swp1.cx-8, Swp2.y+5,
                  0, 0,
                  SWP_MOVE);
  // (Description MLE: minimum height is 125, but around 1/3rd of available space)
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_SETUPGAME), Swp1);
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, ST_DESCRIPTION), Swp3);
  ulTemp:=((Swp2.cy-Swp1.cy-Swp3.cy)*1-10) div 3;
  if ulTemp<125 then ulTemp:=125;
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, MLE_DESCRIPTIONOFTHESELECTEDGAME), HWND_TOP,
                  Swp2.x+10, Swp1.y+Swp1.cy+5,
                  Swp2.cx-20, ulTemp,
                  SWP_SIZE or SWP_MOVE);

  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, MLE_DESCRIPTIONOFTHESELECTEDGAME), Swp1);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, ST_DESCRIPTION), HWND_TOP,
                  Swp2.x+5, Swp1.y+Swp1.cy+2,
                  Swp2.cx-10, Swp3.cy,
                  SWP_SIZE or SWP_MOVE);

  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, ST_DESCRIPTION), Swp3);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, LB_GAMES), HWND_TOP,
                  Swp2.x+10, Swp3.y+Swp3.cy+2,
                  Swp2.cx-20, Swp2.y+Swp2.cy-Swp3.y-Swp3.cy-26,
                  SWP_SIZE or SWP_MOVE);

  // GB_AVAILABLEPLAYERS
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, GB_ADVANCEDSETTINGS), Swp1);
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_INVITE), Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, GB_AVAILABLEPLAYERS), HWND_TOP,
                  Swp1.x, Swp2.y+Swp2.cy+5,
                  Swp1.cx, Swp1.y-(Swp2.y+Swp2.cy)-5,
                  SWP_SIZE or SWP_MOVE);
  // Things inside GB_AVAILABLEPLAYERS:
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_PINGPLAYER), Swp1);
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, GB_AVAILABLEPLAYERS), Swp2);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, PB_PINGPLAYER), HWND_TOP,
                  Swp2.x+Swp2.cx-Swp1.cx-8, Swp2.y+5,
                  0, 0,
                  SWP_MOVE);
  // (Description MLE: minimum height is 125, but around 1/3rd of available space)
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, PB_PINGPLAYER), Swp1);
  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, ST_INFORMATIONABOUTTHEPLAYER), Swp3);
  ulTemp:=((Swp2.cy-Swp1.cy-Swp3.cy)*1-10) div 3;
  if ulTemp<125 then ulTemp:=125;
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, MLE_INFORMATIONABOUTTHESELECTEDPLAYER), HWND_TOP,
                  Swp2.x+10, Swp1.y+Swp1.cy+5,
                  Swp2.cx-20, ulTemp,
                  SWP_SIZE or SWP_MOVE);

  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, MLE_INFORMATIONABOUTTHESELECTEDPLAYER), Swp1);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, ST_INFORMATIONABOUTTHEPLAYER), HWND_TOP,
                  Swp2.x+5, Swp1.y+Swp1.cy+2,
                  Swp2.cx-10, Swp3.cy,
                  SWP_SIZE or SWP_MOVE);

  WinQueryWindowPos(WinWindowFromID(hwndDlgClient, ST_INFORMATIONABOUTTHEPLAYER), Swp3);
  WinSetWindowPos(WinWindowFromID(hwndDlgClient, LB_PLAYERS), HWND_TOP,
                  Swp2.x+10, Swp3.y+Swp3.cy+2,
                  Swp2.cx-20, Swp2.y+Swp2.cy-Swp3.y-Swp3.cy-26,
                  SWP_SIZE or SWP_MOVE);
  WinEnableWindowUpdate(hwndClient, true);
end;

function GameSetupThreadFunc( param:pointer ):longint;
var DLLHandle:HModule;
    rc:ApiRet;
    FName:String;
    pGame : pGameList;
    SetupGameBuf : tSetupGameBuf;
    DLL_SetupGame   : fnSetupGame;
    lTemp : longint;
begin
  pGame := pGameList(param);
  if (pGame<>NIL) then
  begin
    FName:=pGame^.FileName+#0;
    DLLHandle := -1;
    rc:=DosLoadModule(nil, 0, @FName[1], DLLHandle);
    if rc=no_error then
    begin
      rc:=DosQueryProcAddr(DLLHandle, 0, 'SetupGame', @DLL_SetupGame);
      if rc=no_error then
      begin
        SetupGameBuf.ab := WinInitialize(0);
        SetupGameBuf.mq := WinCreateMsgQueue(ab, 0);
        SetupGameBuf.hmod := DLLHandle;

        if (not DLL_SetupGame(sizeof(SetupGameBuf), @SetupGameBuf)) then
            WinMessageBox(HWND_DESKTOP, hwndDlgClient, 'Error setting up the GameDLL!', nil, 0,
                  MB_OK or MB_MOVEABLE or MB_ERROR);

        pGame^.HaveSetup := true; // Restore flag, so the user can start a setup for this game again!
        // Now check if it is this gamedll still selected. If it is, we have to update the state of Setup button!
        lTemp:=WinSendDlgItemMsg( hwndDlgClient, LB_GAMES,
                         LM_QUERYSELECTION, MPARAM(LIT_CURSOR), 0);
        if (pGame = GetGameByIndex(lTemp)) then
          WinEnableControl( hwndDlgClient, PB_SETUPGAME, true);

        WinDestroyMsgQueue(SetupGameBuf.mq);
        WinTerminate(SetupGameBuf.ab);
      end;
      DosFreeModule(DLLHandle);
    end
    else
    pGame^.HaveSetup := true; // Restore flag, so the user can start a setup for this game again!
  end;
end;

function MyDlgProc(Wnd: HWnd; Msg: ULong; Mp1, Mp2: MParam): MResult; cdecl;
var sTemp:string;
    lTemp:longint;
    NewDC:tDirectClientList;
    pNewDC:pDirectClientList;
    pSelectedGame:pGameList;
begin
  case Msg of
    WM_INITDLG:
    begin
      WinSendDlgItemMsg(Wnd, EF_USERNAME, EM_SETTEXTLIMIT, MAX_USERNAME_LENGTH, 0);
      WinSendDlgItemMsg(Wnd, EF_SERVERPORT, EM_SETTEXTLIMIT, 80, 0);
      result:=0;
      exit;
    end; // of WM_INITDLG
    WM_COMMAND:
    begin
      case Short1FromMP(MP2) of  // ussource parameter of WM_COMMAND
        CMDSRC_PUSHBUTTON:
        begin
          case MP1 of
            PB_SETUPGAME:
            begin
              lTemp:=WinSendDlgItemMsg( hwndDlgClient, LB_GAMES,
                         LM_QUERYSELECTION, MPARAM(LIT_CURSOR), 0);
              pSelectedGame:=GetGameByIndex(lTemp);
              if (pSelectedgame<>NIL) and (pSelectedGame^.HaveSetup) then
              begin
                // Start a new thread to do the setup of this game!
                pSelectedGame^.HaveSetup := false; // Make sure the user will not start a setup for
                                                   // this game again!
                WinEnableControl( hwndDlgClient, PB_SETUPGAME, false);

                VPBeginThread(GameSetupThreadFunc, 16384, pSelectedGame);
              end;
              result:=1; exit;
            end;
            PB_PINGPLAYER:
            begin
              result:=1; exit;
            end;
            PB_INVITE:
            begin
              // Get selected player info
              NewDC.PlayerToInvite:=GetPlayerByID(
                 GetSelectedListBoxItemHandle(hwndDlgClient, LB_PLAYERS));
              if NewDC.PlayerToInvite=nil then
              begin
                WinMessageBox(HWND_DESKTOP, wnd, 'Please select a player to play with!', nil, 0,
                  MB_OK or MB_MOVEABLE or MB_ERROR);
              end else
              begin
                // Get selected game info
                lTemp:=WinSendDlgItemMsg( hwndDlgClient, LB_GAMES,
                         LM_QUERYSELECTION, MPARAM(LIT_CURSOR), 0);
                NewDC.GameToInvite:=GetGameByIndex(lTemp);
                NewDC.MySocket:=-1;
                pNewDC:=AddNewDirectClient(NewDC);
                if pNewDC=Nil then
                begin
                  WinMessageBox(HWND_DESKTOP, wnd, 'Could not create new connection!', nil, 0,
                    MB_OK or MB_MOVEABLE or MB_ERROR);
                end else
                begin
                  // Start a new thread to communicate with other client, to invite for a game:
                  pNewDC^.ThreadID:=VPBeginThread(InvitorThreadFunc, 16384, pNewDC);
                  DosSleep(50);
                  DosSetPriority(prtys_Thread,prtyc_Regular,+1,
                    pNewDC^.ThreadID);
                end;
              end;
              result:=1; exit;
            end;
            PB_QUIT:
            begin
              WinPostMsg(hwndFrame, WM_CLOSE, 0, 0);
              result:=1; exit;
            end;
          end;
        end; // of CMDSCR_PUSHBUTTON
      end;
    end; // of WM_COMMAND
    WM_CONTROL:
    begin
      case Short1FromMP(MP1) of  // ID of control that sent WM_CONTROL message
        EF_USERNAME:
        begin
          case Short2FromMP(MP1) of
            EN_SETFOCUS:
            begin
              SavedUserName:=WinQueryDlgItemTextPas(Wnd, EF_USERNAME);
              result:=0; exit;
            end;
            EN_KILLFOCUS:
            begin
              sTemp:=WinQueryDlgItemTextPas(Wnd, EF_USERNAME);
              if not AcceptableUserName(sTemp) then
                WinSetDlgItemTextPas(Wnd, EF_USERNAME, SavedUserName)
              else
              if sTemp<>SavedUserName then
                SendString(ServerSocket,'SET NAME "'+sTemp+'"');
              result:=0; exit;
            end;
          end;
        end;

        EF_SERVERPORT:
        begin
          case Short2FromMP(MP1) of
            EN_SETFOCUS:
            begin
              SavedServerPort:=WinQueryDlgItemTextPas(Wnd, EF_SERVERPORT);
              result:=0; exit;
            end;
            EN_KILLFOCUS:
            begin
              sTemp:=WinQueryDlgItemTextPas(Wnd, EF_SERVERPORT);
              if not AcceptableServerPort(sTemp) then
                WinSetDlgItemTextPas(Wnd, EF_SERVERPORT, SavedServerPort)
              else
              if sTemp<>SavedServerPort then
              begin
                sServerPort:=sTemp;
                Reconnect:=True;
                so_cancel(ServerSocket);
              end;
              result:=0; exit;
            end;
          end;
        end;

        LB_GAMES:
        begin
          case Short2FromMP(MP1) of
            LN_SELECT:
            begin
{$ifdef DebugConsole}
              writeln(' GameListItemSelected');
{$endif}
              WinSendDlgItemMsg( hwndDlgClient, MLE_DESCRIPTIONOFTHESELECTEDGAME,
                         MLM_DELETE, 0, MAXLONGINT);
              lTemp:=WinSendDlgItemMsg( hwndDlgClient, LB_GAMES,
                         LM_QUERYSELECTION, MPARAM(LIT_CURSOR), 0);
              sTemp:=GetGameDescByIndex(lTemp)+#0;
              pSelectedGame:=GetGameByIndex(lTemp);
              lTemp:=WinSendDlgItemMsg( hwndDlgClient, MLE_DESCRIPTIONOFTHESELECTEDGAME,
                          MLM_INSERT, MPARAM(@sTemp[1]), 0);
              WinSendDlgItemMsg(hwndDlgClient, MLE_DESCRIPTIONOFTHESELECTEDGAME,
                          MLM_SETSEL, 0, 0);

              if (pSelectedGame<>nil) then
                WinEnableControl( hwndDlgClient, PB_SETUPGAME, pSelectedGame^.HaveSetup)
              else
                WinEnableControl( hwndDlgClient, PB_SETUPGAME, false);

              result:=0; exit;
            end;
          end;
        end;

      end;
    end; // of WM_CONTROL
    WM_CHAR : // Process ESC key, so it won't close the window!
        if (Short1FromMP(Mp1) AND KC_VIRTUALKEY <> 0) and
           (Short2FromMP(Mp2)=VK_ESC) then
        begin
          result:=MRESULT(true);
          exit;
        end;
  end; // of Case MSG of
  result:=WinDefDlgProc(Wnd,Msg,Mp1,Mp2);
end;

function AboutDialogProc(Wnd: HWnd; Msg: ULong; Mp1, Mp2: MParam): MResult; cdecl;
var dlg:hwnd;
    ix,iy:longint;
    DlgSwap, ParentSwap:SWP;
begin
  case Msg of
    WM_COMMAND:
    begin
      case Short1FromMP(MP2) of  // ussource parameter of WM_COMMAND
        CMDSRC_PUSHBUTTON:
        begin
          case MP1 of
            PB_CREATEDBY:
            begin
              dlg:=WinLoadDlg(HWND_DESKTOP, wnd, Nil, NULLHANDLE, DLG_CREATEDBY, nil);
              if Dlg<>0 then
              begin
                if WinQueryWindowPos(Dlg,DlgSwap) then
                if WinQueryWindowPos(Wnd,ParentSwap) then
                begin
                  // Center dialog box within the parent window
                  ix := ParentSwap.x + (ParentSwap.cx - DlgSwap.cx) div 2;
                  iy := ParentSwap.y + (ParentSwap.cy - DlgSwap.cy) div 2;
                  WinSetWindowPos(Dlg, HWND_TOP, ix, iy, 0, 0, SWP_MOVE or SWP_SHOW or SWP_ACTIVATE);
                end;
                WinProcessDlg(Dlg);
                WinDestroyWindow(Dlg);
              end;
              result:=longint(TRUE); exit;
            end;
          end;
        end; // of CMDSCR_PUSHBUTTON
      end;
    end;
  end;
  result:=WinDefDlgProc(Wnd,Msg,Mp1,Mp2);
end;

function MainWindowProc(Wnd: HWnd; Msg: ULong; Mp1, Mp2: MParam): MResult; cdecl;
var dlg:hwnd;
    ix,iy:longint;
    DlgSwap, ParentSwap:SWP;
begin
  case Msg of
    WM_COMMAND:
    begin
      case Short1FromMP(MP1) of
        IDM_PRODUCTINFORMATION:
        begin
          dlg:=WinLoadDlg(HWND_DESKTOP, hwndFrame, AboutDialogProc, NULLHANDLE, DLG_ABOUTNETGAMECLIENT, nil);
          if Dlg<>0 then
          begin
            if WinQueryWindowPos(Dlg,DlgSwap) then
            if WinQueryWindowPos(hwndFrame,ParentSwap) then
            begin
              // Center dialog box within the parent window
              ix := ParentSwap.x + (ParentSwap.cx - DlgSwap.cx) div 2;
              iy := ParentSwap.y + (ParentSwap.cy - DlgSwap.cy) div 2;
              WinSetWindowPos(Dlg, HWND_TOP, ix, iy, 0, 0, SWP_MOVE or SWP_SHOW or SWP_ACTIVATE);
            end;
            WinProcessDlg(Dlg);
            WinDestroyWindow(Dlg);
          end;
          result:=longint(TRUE); exit;
        end;
        IDM_EXIT:
        begin
          WinPostMsg(hwndFrame, WM_CLOSE, 0, 0);
          result:=longint(TRUE); exit;
        end;
      end;
    end; // of WM_COMMAND
    WM_SIZE: // The main window has been resized!
    begin
      ResizeMainWindowControls(Wnd, Short1FromMP(MP2), Short2FromMP(MP2));
      result:=0;
      exit;
    end;
    WM_SAVEAPPLICATION:
      WinStoreWindowPos(WinStateSave_Name, WinStateSave_Key, hwndFrame);

  end;
  result:=WinDefWindowProc(Wnd,Msg,Mp1,Mp2);
end;

function NewFrameProc(Wnd: HWnd; Msg: ULong; Mp1, Mp2: MParam): MResult; cdecl;
var OldFrameProc:FNWP;
    ti:PTRACKINFO;
begin
  @OldFrameProc:=pointer(WinQueryWindowULong(Wnd, QWL_USER));
  if MSG=WM_QUERYTRACKINFO then                 // Limit minimal window size!
  begin
    result:=OldFrameProc(Wnd, Msg, Mp1, Mp2);
    ti:=PTRACKINFO(Mp2);
    ti^.ptlMinTrackSize.X:=400;
    ti^.ptlMinTrackSize.Y:=420;
  end else
  result:=OldFrameProc(Wnd, Msg, Mp1, Mp2);
end;

function GetWindowTitleStyleFromRC(Module:HMODULE; res_ID:longint; var Title:string; var Flags:longint):boolean;
const WINCLASS_FRAME = $00000001;
var pdlgt:PDLGTEMPLATE;
    cItems, i:longint;
    padlgti:pdlgtitem;
    pvText:pointer;
begin
  result:=false;
  if (DosGetResource(Module, RT_DIALOG, res_ID, pointer(pdlgt))<>no_error) or
     (pdlgt=nil) then exit;


  with pdlgt^ do
  begin
    // Save the number of controls found within the dialog template
    cItems:=pdlgt^.adlgti.cChildren + 1;
    // Read and translate each of the controls

    padlgti:=@(pdlgt^.adlgti);
    for i:=1 to cItems do
    begin

      // Check to see if a custom class is specified, or
      // if a standard PM control class is being used

      if (padlgti^.cchClassName=0) and (padlgti.offClassName=WINCLASS_FRAME) then
      begin
        // Check if any text specified for the control
        if padlgti^.cchText<>0 then
          pvText:=pointer(longint(pdlgt)+padlgti^.offText)
        else pvText:=nil;

        Flags:=padlgti^.flstyle;
        title:=StrPas(pchar(pvText));
        break;
      end;
      inc(longint(padlgti), sizeof(dlgtitem));
    end;

  end;
  DosFreeResource(pointer(pdlgt));
  result:=true;
end;

function PMThreadFunc( p:pointer ):longint;
var flStyle, flCreaFlags:longint;
    swap:SWP;
    AppTitle:String;
    Msg:QMSG;
    pOldFrameProc:pointer;
begin
  // Initialize PM
  InitPM;
  // Create main window
  WinRegisterClass(ab, pszPrivateClassName, // Register a private class, so
                   MainWindowProc,          // we can use our own window procedure
                   0, 0);
  //    Set defaults for main window:
  flCreaFlags:=
            FCF_TASKLIST or FCF_SYSMENU or FCF_TITLEBAR or
            FCF_SIZEBORDER or
            FCF_DLGBORDER or FCF_MINMAX or FCF_MENU or FCF_ICON or
            FCF_SHELLPOSITION or FCF_NOBYTEALIGN or FCF_AUTOICON;
  flstyle:=FS_NOBYTEALIGN or FS_BORDER or WS_CLIPSIBLINGS or WS_SAVEBITS;
  AppTitle:='New Application';

  //    Now get what we can from the resource (app. title and window style)
  GetWindowTitleStyleFromRC(NULLHANDLE, WIN_NETGAMECLIENT, AppTitle, flStyle);
  AppTitle:=AppTitle+#0;                // Create c-style string
  flStyle:=flStyle and not WS_VISIBLE;  // Make sure the window will not be created visible

  hwndFrame :=  WinCreateStdWindow(HWND_DESKTOP,           // Create frame window
                                   flStyle,
                                   flCreaFlags,
                                   pszPrivateClassName,
                                   @AppTitle[1],
                                   0,
                                   NULLHANDLE,
                                   WIN_NETGAMECLIENT,
                                   @hwndClient);

  pOldFrameProc := WinSubclassWindow(hwndFrame, NewFrameProc);  // Subclass window frame to be able to
                                                                // limit window size
//  if pfnwpOldFrameProc=nil then // Could not subclass frame window
  WinSetWindowULong(hwndFrame, QWL_USER, ULONG(pOldFrameProc));  // Store old window procedure in frame window's ulong

  hwndDlgClient := WinLoadDlg(hwndClient,                  // Create controls inside frame
                              hwndClient,
                              MyDlgProc,
                              NULLHANDLE,
                              WIN_NETGAMECLIENT,
                              nil);

  WinQueryWindowPos(hwndDlgClient, swap);
  WinSetWindowPos(hwndFrame, 0, 0,0,                       // Set frame size to dialog size, and show it!
                  swap.cx,
                  swap.cy+WinQuerySysValue(HWND_DESKTOP, SV_CYTITLEBAR),
                  SWP_SIZE);

  WinSetWindowPos(hwndDlgClient,                           // Set dialog position inside frame window
                  HWND_TOP,
                  -WinQuerySysValue(HWND_DESKTOP, SV_CXDLGFRAME),
                  -WinQuerySysValue(HWND_DESKTOP, SV_CYDLGFRAME),
                  0, 0,
                  SWP_MOVE or SWP_ZORDER or SWP_SHOW);

  // Now try to reload size and position information from INI file:
  WinRestoreWindowPos(WinStateSave_Name, WinStateSave_Key, hwndFrame);

  // Move the window more down if it would be out of the screen!
  WinQueryWindowPos(hwndFrame, swap);
  if (Swap.y+Swap.cy > WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN)) then
  begin
    WinSetWindowPos(hwndFrame, HWND_TOP, Swap.x, WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN)- Swap.cy, 0, 0, SWP_MOVE);
    WinQueryWindowPos(hwndFrame, swap);
  end;
  if (Swap.x+Swap.cx > WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN)) then
  begin
    if WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN)-Swap.cx>=0 then
    WinSetWindowPos(hwndFrame, HWND_TOP, WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN)- Swap.cx, Swap.y, 0, 0, SWP_MOVE);
  end;

  WinShowWindow(hwndFrame, true);

  GUI_Ready:=True;
  WinProcessDlg(hwndDlgClient);          // Process messages until window closed (or WM_QUIT message)
   // Note that in normal case, this would end if the user presses the ESC key, but we
   // filter that out in the window procedure!

  ShuttingDown:=true;
  GUI_Ready:=False;

  WinDestroyWindow(hwndFrame);       // Destroy windows
  // Uninitialize PM
  UninitPM;
  tidPM:=-1; // Thread ended.
end;

function ServerCommThreadFunc( p:pointer ):longint;
var rc:longint;
    Cmd:string;

  function ConnectToServer:boolean;
  var server:sockaddr_in;
      hp:phostent;
      s:String;
      code:longint;
      size:longint;
      BlockMode:longint;
      NoTries:longint;
  begin
    result:=false;

    fillchar(server,sizeof(server),0);

    Server.sin_family  := AF_INET;
    s:=copy(sServerPort,1,pos(':',sServerPort)-1)+#0;        // Get the host part!
    server.sin_addr:=inet_addr(@s[1]);
    if server.sin_addr=-1 then
    begin // it wasn't a number, so try to get the IP by name!
      hp:=gethostbyname(@s[1]);
      if hp=nil then exit; // could not get the IP address!
      move((hp^.h_addr_list^)^,server.sin_addr, sizeof(server.sin_addr));
    end;

    s:=copy(sServerPort,pos(':',sServerPort)+1,length(sServerPort));  // Get the port part
    val(s,Server.sin_port,code);
    if code<>0 then exit;

    Server.sin_port:=htons(Server.sin_port);

    code:=connect(ServerSocket,sockaddr(server),sizeof(server));
    if (code<>0) then exit;

    result:=true;
  end;

  procedure ProcessCommand(s:String);
  var data:tPlayerDataList;
      sTemp:string;
      pdata:pPlayerDataList;
      l:longint;
  begin
    if s='PING' then SendString(ServerSocket,'PONG') else /////////////////////////////////////////////////
    if copy(s,1,7)='YOURID ' then /////////////////////////////////////////////////////////////////////////
    begin
      MyID:=StrToLong(copy(s,8,length(s)));
      pData:=GetPlayerByID(MyID);
      if pData<>nil then
      begin
        data:=pdata^;
        l:=GetListBoxItemIndexByHandle(hwndDlgCLient, LB_PLAYERS, MyID);
        if l<>-1 then
          WinSendDlgItemMsg(hwndDlgClient, LB_PLAYERS,
                            LM_DELETEITEM, l, 0);
        ModifyOrAddPlayerData(Data);
      end;
    end else
    if copy(s,1,11)='CLIENTINFO ' then ////////////////////////////////////////////////////////////////////
    begin
      delete(s,1,11);

      sTemp:=copy(s,1,pos(' ',s)-1);
      data.lID:=StrToLong(sTemp);
      delete(s,1,pos(' ',s));

      pData:=GetPlayerByID(data.lID);
      if pData<>nil then data:=pdata^;

      sTemp:=copy(s,1,pos(' ',s)-1);
      data.bType:=StrToLong(sTemp);
      delete(s,1,pos(' ',s));

      data.sName:=GetSafeString(s);
      delete(s,1,length(data.sName));
      delete(s,1,pos(' ',s));

      sTemp:=copy(s,1,pos(' ',s)-1);
      data.lSrvAddress:=StrToLong(sTemp);
      delete(s,1,pos(' ',s));

//      sTemp:=copy(s,1,pos(' ',s)-1);
      sTemp:=s;
      data.lSrvPort:=StrToLong(sTemp);
      delete(s,1,pos(' ',s));

      l:=GetListBoxItemIndexByHandle(hwndDlgClient, LB_PLAYERS, data.lID);
      if l<>-1 then
         WinSendDlgItemMsg(hwndDlgClient, LB_PLAYERS,
                           LM_DELETEITEM, l, 0);


      if data.lID=MyID then
      begin
        sUserName:=data.sName;
        sTemp:=sUserName+#0;
        WinSetDlgItemText(hwndDlgClient, EF_USERNAME, @sTemp[1]);
      end else
      if data.bType=CLIENT_PLAYER then
      begin // Show in list only if it's a player!
        sTemp:=FormatPlayerData(@data)+#0;
        l:=WinSendDlgItemMsg(hwndDlgClient, LB_PLAYERS,
                             LM_INSERTITEM, LIT_SORTASCENDING, mparam(@sTemp[1]));
        WinSendDlgItemMsg(hwndDlgClient, LB_PLAYERS,
                          LM_SETITEMHANDLE, mparam(l), mparam(data.lID));
      end;
      ModifyOrAddPlayerData(Data);

    end else
    if copy(s,1,11)='REMOVEUSER ' then ////////////////////////////////////////////////////////////////////
    begin
      delete(s,1,11);
      l:=StrToLong(s);
      pData:=GetPlayerByID(l);
      if pData<>nil then
      begin
        l:=GetListBoxItemIndexByHandle(hwndDlgClient, LB_PLAYERS, pdata^.lID);
        if l<>-1 then
          WinSendDlgItemMsg(hwndDlgClient, LB_PLAYERS,
                            LM_DELETEITEM, l, 0);
        DeletePlayer(pData);
      end;
    end;
  end;

begin
  InitPM;
  ServerSocket:=-1;
  ServerComm_Ready:=True;
  repeat
    ServerSocket:=socket(AF_INET,SOCK_STREAM,0);
    if (ServerSocket>=0) then
    begin
      SetStatusLine('Connecting to server...');
      SetStatusLineColor(PP_BACKGROUNDCOLOR, $000000A0); // Blue
      DosSleep(64);
      if ConnectToServer then // Try to connect!
      begin
        SetStatusLine('Connected to server.');
        SetStatusLineColor(PP_BACKGROUNDCOLOR, $00008000); // Green
        MyID:=-1;
        SendString(ServerSocket,'SET NAME "'+sUserName+'"');            // Setup on the server!
        SendString(ServerSocket,'SET TYPE '+LongToStr(CLIENT_PLAYER));
        SendString(ServerSocket,'SET DIRECTADDR '+LongToStr(LocalServerIP)+' '+LongToStr(LocalServerPort));

        WinSendDlgItemMsg(hwndDlgClient, LB_PLAYERS, // Delete listbox of players
                          LM_DELETEALL, 0, 0);
        Erase_ListOfPlayers;

        SendString(ServerSocket,'GET CLIENTINFO ALL');
        Reconnect:=false;
        repeat
          Cmd:=ReceiveString(ServerSocket);
          if Cmd<>'' then ProcessCommand(Cmd);
        until ShuttingDown or (cmd='') or Reconnect;
        SetStatusLine('Disconnecting...');
        SetStatusLineColor(PP_BACKGROUNDCOLOR, $00606060); // Gray
        SendString(ServerSocket, 'DISCONNECT');
      end else
      begin
        SetStatusLine('Could not connect to server!');
        SetStatusLineColor(PP_BACKGROUNDCOLOR, $00B00000); // Red
      end;
      rc:=soclose(ServerSocket);
    end;
    ServerSocket:=-1;
    DosSleep(1000);
  until ShuttingDown;
  ServerComm_Ready:=false;
  UninitPM;
  tidServerComm:=-1;
end;

function DirectClientServerThreadFunc( p:pointer ):longint;
label EndOfConnection, Cleanup;
var Client:tDirectClientList;
    cmd:string;
    GameName, PlayerName : string;
    NetCommMaj, NetCommMin:SmallWord;
    code:longint;
    CompGame:pGameList;
    sent:boolean;

    InitBuf:pInitBuf;
    StartClientBuf:pStartClientBuf;

begin
  InitPM;
  if p<>nil then
  begin
    Client:=pDirectClientList(p)^;
    with Client do
    begin
      SendString(MySocket, 'DIRECT-CLIENT CONNECTION READY.');
      if WinQueryButtonCheckstate(hwndDlgClient, CB_AUTOREJECTINVITATIONS)=1 then
      begin // If auto-reject is on, then do auto-reject. :)
        SendErrorString(MySocket, 008); // Not accepted by user!
        goto EndOfConnection;
      end;
      // Let's check what is the game that this stranger wants to play with us:
      cmd:=ReceiveString_TimeOut(MySocket, DIRECTCLIENT_TIMEOUT);
      if (copy(cmd,1,7)<>'INVITE ') then   // for example: INVITE "Doodle" "Chat" 0 2
      begin
        SendErrorString(MySocket, 005); // Invalid protocol
        goto EndOfConnection;
      end;
      // Ok, it's an invitation for a game. Let's check what kind of game it is!
      delete(cmd,1,7);
      PlayerName:=GetSafeString(cmd);     // Get name of invitor (player/client)
      delete(cmd,1,length(PlayerName)+3);

      GameName:=GetSafeString(cmd);       // Get name of game
      delete(cmd,1,length(GameName)+3);

      val(copy(cmd,1,pos(' ',cmd)-1), NetCommMaj, code);   // Get NetCommVerMaj
      if code<>0 then
      begin
        SendErrorString(MySocket, 006); // Invalid parameter!
        goto EndOfConnection;
      end;
      delete(cmd,1,pos(' ',cmd));

      val(cmd, NetCommMin, code);   // Get NetCommVerMin
      if code<>0 then
      begin
        SendErrorString(MySocket, 006); // Invalid parameter!
        goto EndOfConnection;
      end;

      // Check if we have a compatible game for this
      CompGame:=GetCompatibleGame(GameName, NetCommMaj, NetCommMin);

      if CompGame=nil then
      begin // We don't have a compatible game
        SendErrorString(MySocket, 007); // No such game here!
        goto EndOfConnection;
      end;

      // Ask if the player accepts this
      cmd:=PlayerName+' is inviting you for '+GameName+'!'+#10+#13+
           'Do you accept it?'+#0;
      if WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, @cmd[1], 'Invitation arrived', 0,
                       MB_YESNO or MB_MOVEABLE or MB_ICONQUESTION)<>MBID_YES then
      begin
        SendErrorString(MySocket, 008); // Not accepted by user!
        goto EndOfConnection;
      end;

      sent:=SendString(MySocket,'ACCEPTED');

      // Last time connection-check:
      if not Sent then
      begin
        WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, 'The peer has closed the connection!','Connection lost', 0, MB_OK or MB_MOVEABLE or MB_ERROR);
        goto EndOfConnection;
      end;

      // Play the game!

      if CompGame^.GameInfo.lGameType=GT_DUEL then
      begin // it's a DUEL type game, that will use this socket for the connection, so all we
            // have to do is to initialize the dll and run the game!
        //------------------------------------------------------------------------------------------------------------
        if not LoadGameDLL(CompGame^.FileName) then
        begin
          WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, 'Could not load game DLL!','Error loading DLL', 0, MB_OK or MB_MOVEABLE or MB_ICONEXCLAMATION);
          goto EndOfConnection;
        end;
        // Ok, dll loaded locally, allocate some memory for parameters!

        new(InitBuf);
        new(StartClientBuf);
        if (InitBuf=nil) or (StartClientBuf=nil) then
        begin
          WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, 'Could not allocate memory!','Out of memory', 0, MB_OK or MB_MOVEABLE or MB_ICONEXCLAMATION);
          UnloadGameDLL;
          goto EndOfConnection;
        end;

        // Initialize game dll

        with InitBuf^ do
        begin // Set helper functions for this game:
          SendMessage:=@SendMessagePChar;
          ReceiveMessage:=@ReceiveMessagePChar;
        end;

        if not InitializeGameDLL(sizeof(InitBuf^), InitBuf) then
        begin
          WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, 'Error initializing game!','Initialization error', 0, MB_OK or MB_MOVEABLE or MB_ICONEXCLAMATION);
          dispose(StartClientBuf);
          dispose(InitBuf);
          UnloadGameDLL;
          goto EndOfConnection;
        end;

        // Start game in client mode!

        with StartClientBuf^ do
        begin
          Socket:=MySocket;
          hMod:=GameDLLHandle;
          fillchar(LocalUserName, sizeof(LocalUserName), 0);
          fillchar(RemoteUserName, sizeof(RemoteUserName), 0);
          move(sUserName[1], LocalUserName, length(sUserName));
          move(PlayerName[1], RemoteUserName, length(PlayerName));
        end;
        StartClientBuf^.AB:=AB;
        StartClientBuf^.MQ:=MQ;

        if not StartGame_ClientMode(sizeof(StartClientBuf^), StartClientBuf) then
        begin
          WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, 'Could not start game!','Error starting game', 0, MB_OK or MB_MOVEABLE or MB_ICONEXCLAMATION);
          dispose(StartClientBuf);
          dispose(InitBuf);
          UnloadGameDLL;
          goto EndOfConnection;
        end;
        // Cleanup after the game

        dispose(StartClientBuf);
        dispose(InitBuf);
        UnloadGameDLL;
        //------------------------------------------------------------------------------------------------------------
      end else
      if CompGame^.GameInfo.lGameType=GT_MULTIPLAYER then
      begin // it's a Multiplayer game, so:
        // DLL_Handshake
        // asasasaasd  (DLL_Handshake_Client)
        // So, they have made their own connection line, we can close this:
        SendString(MySocket, 'DISCONNECT');
        soclose(MySocket); MySocket:=-1;
        // Let the game begin!
        // asdasdasdasd (DLL_StartGame_Multiplayer())
        // End!
        goto Cleanup;
      end else
      begin
        SendErrorString(MySocket,009); // Not supported game type!
      end;

     EndOfConnection:  // Cleanup after the client
      SendString(MySocket, 'DISCONNECT');
      soclose(MySocket);
     Cleanup:
      DeleteOldDirectClient(p);
    end;
  end;
  UninitPM;
end;

function LocalServerThreadFunc( p:pointer ):longint; // Thread that waits for direct-client connections, and
var                                                  // starts a DirectClientServerThread for each of them
  aSock    : longint;
  Server,aClient  :SockAddr_in;
  SockAddr_Size:longint;
  Serv     : ServEnt;
  NewClData: tDirectClientList;
  pNewClData : pDirectClientList;
  SocketInfo : SockAddr_in;
  SocketInfoSize : longint;
  rc:longint;

begin
  InitPM;
  LocalServerSocket:=-1;
  LocalServer_Ready:=True;

  repeat
    LocalServerSocket:=Socket(PF_INET,SOCK_STREAM,0);  // Open a socket
    if LocalServerSocket>=0 then
    begin
      fillchar(Server, sizeof(Server), 0);
      Server.sin_family  := AF_INET;
      Server.sin_port  := 0; // Let the system assign a port
      Server.sin_addr := INADDR_ANY;
      rc:=Bind(LocalServerSocket,SockAddr(Server), sizeof(SockAddr));      // Bind the socket to the port
      if rc=0 then
      begin // Successfully binded
        SocketInfoSize:=sizeof(SocketInfo);
        getsockname(LocalServerSocket, SockAddr(SocketInfo), SocketInfoSize);
        LocalServerIP:=htonl(gethostid);
        LocalServerPort:=SocketInfo.sin_port;
        SendString(ServerSocket,'SET DIRECTADDR '+LongToStr(LocalServerIP)+' '+LongToStr(LocalServerPort)+' ');
        NumOfLocalServerClients:=0;
        while (listen(LocalServerSocket,5)=0) and (not ShuttingDown) do
        begin   // Listen for anything interesting
          SockAddr_Size:=sizeof(SockAddr);
          aSock:=accept(LocalServerSocket,@(SockAddr(aClient)), @SockAddr_Size);
          if aSock>=0 then
          begin
            if (NumOfLocalServerClients>=MAX_LOCALSERVERCLIENTS) then
            begin
              SendErrorString(aSock, 001); // Too many clients!
              SendString(aSock,'DISCONNECT');
              soClose(aSock);
            end else
            begin
              with NewClData do
              begin
                MySocket:=aSock;
                Remote:=aClient;
              end;
              pNewClData:=AddNewDirectClient(NewClData);

              pNewClData^.ThreadID:=vpbeginthread(DirectClientServerThreadFunc,16384,pNewClData);
              DosSleep(50);
              DosSetPriority(prtys_Thread,prtyc_TimeCritical,+1,
                 pNewClData^.ThreadID);
            end;
          end;
        end;
      end;
      soclose(LocalServerSocket);
      LocalServerIP:=-1;
      LocalServerPort:=-1;
      SendString(ServerSocket, 'SET DIRECTADDR -1 -1');
    end;
    DosSleep(500);
  until ShuttingDown;

  ServerComm_Ready:=false;
  UninitPM;
  tidLocalServer:=-1;
end;

procedure Init_Variables; // Initialize global variables
begin
  PlayerDatasProtector_Sem:=-1;
  tidPM:=-1; // Indicate that PMThread is not running
  GUI_Ready:=false;
  tidServerComm:=-1;
  ServerSocket:=-1;
  ServerComm_Ready:=false;
  ShuttingDown:=false;
  PlayerDatasHead:=nil;

  LocalServerSocket:=-1;
  LocalServerIP:=-1;
  LocalServerPort:=-1;
  LocalServer_Ready:=false;
  tidLocalServer:=-1;

  DirectClientListHead:=nil;
  GameListHead:=nil;
end;

procedure Shutdown_PMThread;
begin
  if tidPM<>-1 then
  begin
    WinPostMsg(hwndFrame, WM_QUIT, 0, 0);
    DosWaitThread(tidPM, dcww_Wait);
  end;
end;

procedure Shutdown_ServerCommThread;
var rc,Counter:longint;
begin
  if tidServerComm<>-1 then
  begin
    counter:=0;
    repeat
      so_cancel(ServerSocket);
      rc:=DosWaitThread(tidServerComm, dcww_NoWait);
      DosSleep(32); inc(Counter);
    until (rc=error_thread_not_terminated) or (Counter>20);
    if rc=error_thread_not_terminated then
    begin
      DosKillThread(tidServerComm);
      if ServerSocket<>-1 then
      begin
        SendString(ServerSocket,#10+#13+'DISCONNECT');
        soclose(ServerSocket);
        ServerSocket:=-1;
      end;
    end;
  end;
end;

procedure Shutdown_LocalServer;
var rc,Counter:longint;
begin
  if tidLocalServer<>-1 then
  begin
    counter:=0;
    repeat
      so_cancel(LocalServerSocket);
      rc:=DosWaitThread(tidLocalServer, dcww_NoWait);
      DosSleep(32); inc(Counter);
    until (rc=error_thread_not_terminated) or (Counter>20);
    if rc=error_thread_not_terminated then
    begin
      DosKillThread(tidLocalServer);
      if LocalServerSocket<>-1 then
      begin
        soclose(LocalServerSocket);
        LocalServerSocket:=-1;
      end;
    end;
  end;

  // Cleanup clients:
  while DirectClientListHead<>nil do
  begin
    so_cancel(DirectClientListHead^.MySocket);
    soclose(DirectClientListHead^.MySocket);
    DosKillThread(DirectClientListHead^.ThreadID);
    DeleteOldDirectClient(DirectClientListHead);
  end;
end;


procedure Load_Settings;
var f:text;
begin
  assign(f,'Settings.cli');
  {$I-}
  reset(f);
  {$I+}
  if ioresult<>0 then exit;
  readln(f, sUsername);
  readln(f, sServerPort);
  close(f);
end;

procedure Save_Settings;
var f:text;
begin
  assign(f,'Settings.cli');
  {$I-}
  rewrite(f);
  {$I+}
  if ioresult<>0 then exit;
  writeln(f, sUsername);
  writeln(f, sServerPort);
  close(f);
end;

procedure Show_Settings;
var cstr:string;
begin
  cstr:=sUsername+#0;
  WinSetDlgItemText( hwndDlgClient, EF_USERNAME, @cstr[1]);
  cstr:=sServerPort+#0;
  WinSetDlgItemText( hwndDlgClient, EF_SERVERPORT, @cstr[1]);
end;

begin
{$IFDEF DebugConsole}
  MorphToPM;
{$ENDIF}
  Init_Variables;

  DosCreateMutexSem(nil,GameListProtector_Sem,0,false);
  DosCreateMutexSem(nil,DirectClientDatasProtector_Sem,0,false);
  DosCreateMutexSem(nil,PlayerDatasProtector_Sem,0,false);

  // Initialize TCP/IP library
  if sock_init<>0 then
  begin
    SysMessageBox('Could not initialize sockets!'+#13+#10+'Make sure you have TCP/IP networking installed!',
                  'Could not initialize sockets',true);
    halt(-1);
  end;

  // Setup this thread for using PM (sending messages etc...)
  InitPM;

  DosSetPriority(prtys_Thread, prtyc_Regular, +30, 0);

  // Start PM-Thread:
  //  Build GUI, and process GUI messages, then cleanup PM resources
{$ifdef DebugConsole}
  Write('Starting PM Thread... ');
{$endif}
  tidPM:=VPBeginThread( PMThreadFunc, 16384, nil);
  while not GUI_Ready do DosSleep(32); // Wait until the GUI is ready
  DosSetPriority(prtys_Thread, prtyc_Regular, +2, tidPM);
{$ifdef DebugConsole}
  Writeln('Done');
{$endif}

  Load_Settings;
  Show_Settings; // Setup GUI elements according the settings

{$ifdef DebugConsole}
  Writeln('Starting ServerCommThread... ');
{$endif}
  tidServerComm:=VPBeginThread( ServerCommThreadFunc, 16384, nil);
{$ifdef DebugConsole}
  Writeln('Starting LocalServerThread... ');
{$endif}
  tidLocalServer:=VPBeginThread( LocalServerThreadFunc, 16384, nil);
  while not ServerComm_Ready do DosSleep(32); // Wait until ready
  DosSetPriority(prtys_Thread,prtyc_TimeCritical,+3,
                 tidServerComm);
{$ifdef DebugConsole}
  writeln('ServerComm_Ready');
{$endif}
  while not LocalServer_Ready do DosSleep(32); // Wait until ready
  DosSetPriority(prtys_Thread,prtyc_TimeCritical,+2,
                 tidLocalServer);
{$ifdef DebugConsole}
  Writeln('LocalServer_Ready');
{$endif}

{$ifdef DebugConsole}
  writeln('Populating game list');
{$endif}
  FillGameList;

{$ifdef DebugConsole}
  Writeln('Waiting for shutdown');
{$endif}
  DosWaitThread(tidPM, dcww_Wait); // Wait for shutdown
  ShuttingDown:=true;        // Set global shutdown flag

{$ifdef DebugConsole}
  writeln('Emptying game list');
{$endif}
  EraseGameList;

{$ifdef DebugConsole}
  Writeln('Shutting down ServerCommThread...');
{$endif}
  Shutdown_ServerCommThread; // Signal shutdown for ServerCommThread
{$ifdef DebugConsole}
  Writeln('Shutting down LocalServer...');
{$endif}
  Shutdown_LocalServer;
{$ifdef DebugConsole}
  Writeln('Shutting down PMThread...');
{$endif}
  Shutdown_PMThread;         // Signal Shutdown for PMThread

  Save_Settings;
  // Done using PM
  UninitPM;

  Erase_ListOfPlayers;
  DosCloseMutexSem(PlayerDatasProtector_Sem); PlayerDatasProtector_Sem:=-1;
  DosCloseMutexSem(DirectClientDatasProtector_Sem); DirectClientDatasProtector_Sem:=-1;
  DosCloseMutexSem(GameListProtector_Sem); GameListProtector_Sem:=-1;
end.
