

type pPlayerDataList=^tPlayerDataList;
     tPlayerDataList=record
       lID:longint;             // Client ID
       sName:String;            // Client Name
       bType:byte;              // Client Type (Player/Informer/Other)
       lSrvAddress:longint;     // Address + Port to contact the player
       lSrvPort:longint;        //

       next:pPlayerDataList;
     end;

var  PlayerDatasHead:pPlayerDataList;
     PlayerDatasProtector_Sem:HEv;

function AddNewPlayer(data:tPlayerDataList):pPlayerDataList;
var Prev,Temp:pPlayerDataList;
begin
  if PlayerDatasProtector_Sem<>-1 then
    DosRequestMutexSem(PlayerDatasProtector_Sem, sem_indefinite_wait);

  Prev:=Nil;
  Temp:=PlayerDatasHead;
  while Temp<>Nil do
  begin
    Prev:=Temp;
    Temp:=Temp^.Next;
  end;
  Result:=New(pPlayerDataList);
  Result^:=data;
  Result^ .Next:=Nil;
  if Prev=Nil then PlayerDatasHead:=Result else
    Prev^.Next:=Result;

  if PlayerDatasProtector_Sem<>-1 then
    DosReleaseMutexSem(PlayerDatasProtector_Sem);
end;

procedure DeletePlayer(data:pPlayerDataList);
var Prev,Temp:pPlayerDataList;
begin
  if PlayerDatasProtector_Sem<>-1 then
    DosRequestMutexSem(PlayerDatasProtector_Sem, sem_indefinite_wait);

  Prev:=Nil;
  Temp:=PlayerDatasHead;
  while (Temp<>Nil) and (Temp<>data) do
  begin
    Prev:=Temp;
    Temp:=Temp^.Next;
  end;
  if temp<>nil then
  begin // Found, delete it!
    if Prev=Nil then PlayerDatasHead:=Temp^.Next else
    Prev^.Next:=Temp^.Next;

    Dispose(Temp);
  end;

  if PlayerDatasProtector_Sem<>-1 then
    DosReleaseMutexSem(PlayerDatasProtector_Sem);
end;

function GetPlayerByID(ID:longint):pPlayerDataList;
var Temp:pPlayerDataList;
begin
  if PlayerDatasProtector_Sem<>-1 then
    DosRequestMutexSem(PlayerDatasProtector_Sem, sem_indefinite_wait);

  Temp:=PlayerDatasHead;
  while (Temp<>Nil) and (Temp^.lID<>ID) do temp:=temp^.Next;

  result:=temp;

  if PlayerDatasProtector_Sem<>-1 then
    DosReleaseMutexSem(PlayerDatasProtector_Sem);
end;


function ModifyOrAddPlayerData(data:tPlayerDataList):pPlayerDataList;
var Temp:pPlayerDataList;
begin
  if PlayerDatasProtector_Sem<>-1 then
    DosRequestMutexSem(PlayerDatasProtector_Sem, sem_indefinite_wait);

  Temp:=PlayerDatasHead;
  while (Temp<>Nil) and (Temp^.lID<>data.lID) do Temp:=Temp^.Next;

  if temp=nil then
  begin
    AddNewPlayer(data);
    result:=nil;
  end else
  begin
    data.Next:=temp^.Next;
    temp^:=data;
    result:=temp;
  end;

  if PlayerDatasProtector_Sem<>-1 then
    DosReleaseMutexSem(PlayerDatasProtector_Sem);
end;

function FormatPlayerData(data:pPlayerDataList):string;
begin
  result:='';
  if data=nil then exit;
  if PlayerDatasProtector_Sem<>-1 then
    DosRequestMutexSem(PlayerDatasProtector_Sem, sem_indefinite_wait);

  with data^ do
  begin
    result:=sName+' <'+AddressPort2String(lSrvAddress,lSrvPort)+'>';
  end;

  if PlayerDatasProtector_Sem<>-1 then
    DosReleaseMutexSem(PlayerDatasProtector_Sem);
end;

procedure Erase_ListOfPlayers;
begin
  while PlayerDatasHead<>Nil do DeletePlayer(PlayerDatasHead);
end;

